#ifndef __complex_h__	// First time we've included this file?
#define __complex_h__	// Protect against double includes

/********************************************************
 * Complex class					*
 *							*
 * Members defined					*
 *	c = c + c;		// Addition		*
 ********************************************************/
class complex
{
    protected:
	//
	// Complex numbers consists of two parts
	//
	double real_part;	// The real part
	double imaginary_part;	// The imaginary part

    public:
	//
	// Function to return the parts of the number
	//
	double real(void) const
	{
	    return (real_part);
	}
	double imaginary(void) const
	{
	    return (imaginary_part);
	}

	// Default constructor, zero everything
	complex(void)
	{
	   real_part = 0.0;
	   imaginary_part = 0.0;
	}

	// Copy constrcutor
	complex(const complex& other_complex)
	{
	    real_part = other_complex.real_part;
	    imaginary_part = other_complex.imaginary_part;
	}
	    
	// Construct a complex out of two real numbers
	complex(double init_real, double init_imaginary=0.0)
	{
	    real_part = init_real;
	    imaginary_part = init_imaginary;
	}

	// Destructor does nothing
	~complex() {}
};
#endif __complex_h__	// First time we've included this file?
